'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
function TXTParse(data, feed) {
    if (this.isLast()) {
        return feed.end();
    }
    this.remainder = this.remainder || '';

    var separator = void 0;
    try {
        var val = '"'.concat(this.getParam('separator', '\n')).concat('"');
        separator = JSON.parse(val);
    } catch (e) {
        separator = '\n';
    }

    var lines = void 0;
    if (Buffer.isBuffer(data)) {
        lines = data.toString().split(separator);
    } else if (typeof data === 'string') {
        lines = data.split(separator);
    } else {
        lines = ['', ''];
    }
    lines.unshift(this.remainder + lines.shift());
    this.remainder = lines.pop();
    lines.forEach(function (line) {
        feed.write(line);
    });
    feed.end();
}

exports.default = {
    TXTParse: TXTParse
};