'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function URLFetch(data, feed) {
    var url = this.getParam('url');
    var target = this.getParam('target');
    var json = this.getParam('json', false);

    if (this.isLast() || !url) {
        return feed.send(data);
    }
    var options = {
        url: url,
        json: json
    };
    (0, _request2.default)(options, function (error, response, body) {
        if (error) {
            return feed.send(error);
        }
        if (response.statusCode !== 200) {
            var msg = 'Received status code ' + response.statusCode + ' (' + response.statusMessage + ')\'';
            return feed.send(new Error(msg));
        }
        if (target && typeof target === 'string') {
            data[target] = body;
            return feed.send(data);
        }
        return feed.send(body);
    });
}

exports.default = {
    URLFetch: URLFetch
};